// USAR MICROSOFT VISUAL C++ EXPRESS EDITION PARA EXECUTAR O 'PROJETO'

// Prova_1Parcial_S11.cpp : Defines the entry point for the console application.
#include "stdafx.h"   // ver comentrios no stdafx.h

// classe abstrata;
class Geometrico
{	protected: 
      	int x, y;
	public:
		Geometrico(const int xp=0, const int yp=0) { x=xp; y=yp; }
		~Geometrico() { }
		// mtodo virtual puro;
		virtual void desenha() const = 0;		
};

// classe Ponto, derivada de Geometrico;
class Ponto : public Geometrico
{	public:
		Ponto(const int xp=0, const int yp=0):Geometrico(xp, yp) { }
		~Ponto() { }
		
		void desenha() const 
		{ 	// desenha um ponto na tela;
			Console::SetCursorPosition ( x , y ); 
			cout <<  ".";					
		}
	
    	// mtodo que define o operador <
		bool operator< (const Ponto& p)	const		
		{	 if ( x < p.x ) { return true;  } else { return false; }
			 //( x < p.x ) ? { return true; } : { return false; }
		}
};

// classe Elemento
class El
{ private:
      El* pProx; 
      Geometrico* pGeom;
  public:
      El(Geometrico* pG=NULL) { pProx= NULL; pGeom = pG; }
      ~El() {pProx = NULL; pGeom = NULL; }
      
      void setProx(El* p) { pProx = p; }
      El*  getProx()      { return pProx; }
      
      Geometrico* getGeom() { return pGeom;; }
};

// classe Lista;
class Lista
{private:
    // ponteiros para o primeiro e o ltimo elemento da lista;
	El *pPri, *pUlt;						
 public:
	Lista()	{ pPri = NULL; pUlt = NULL; }
	~Lista()	// libera a memria alocada para a lista;			
	{
        El* pAux = NULL;
		while (pPri)
		{ 
            pAux = pPri->getProx();
			delete pPri; 
			pPri = pAux;
		}
		pPri = NULL; pUlt = NULL;
	}

	void inserir(Geometrico* pG)
	{   if (NULL != pG)
		{	
			El* pAux = NULL;
			pAux = new El(pG);
			if ( NULL == pPri )	{ pPri = pAux; 	pUlt = pAux; } 
			else { pUlt->setProx(pAux);	pUlt = pAux; }
		} else {
			cout << "Insercao Invlida!" << endl;
			system ("Pause");
	    }
	}

	void desenha() const
	{
		El *pAux = pPri;
		while (pAux != NULL)
		{
			(pAux->getGeom())->desenha();
			pAux = pAux->getProx();
		}
	}
};

// classe RetaOrtogonal, derivada de Geometrico;
class RetaOrtogonal : public Geometrico
{	private:
		Lista LstPts;
		int tam, vert;
		// cria uma lista com os pontos;
		void criaLista() 
        {
			for(int i=0; i < tam; i++)	// cria uma lista de pontos vertical;
			{
                if (vert){ LstPts.inserir(new Ponto(x,y+i)); }
                else     { LstPts.inserir(new Ponto(x+i,y)); }
            }
		}	
	public:
		//RetaOrtogonal()							{ }
		RetaOrtogonal(const int xp=0, const int yp=0, const int t=0, const int v=0):
        Geometrico(xp, yp)
      	{
			tam = t;	 // armazena o tamanho;
			vert = v;	 // armazena se a reta  vertical (1) ou horizontal (0);
			criaLista(); // chama o mtodo de desenho e cria a lista de pontos;
		}
		~RetaOrtogonal() { }
		// desenha uma lista de pontos na tela;
		void desenha() const { LstPts.desenha(); }
};

// classe Principal;
class Principal
{	private:
		Lista LstObjs;	// lista de pontos e retas atravs de polimorfismo;
		int x, y;
	public:
		Principal()	 { x=y=0; menuPrin(); }
		~Principal() { }
		
		bool lerPonto()
		{
			cout << "Digite x e y " << endl;
			cin >> x >> y;
			if ( ( (x < 80) && (y < 60) ) &&
			     ( (x > 0 ) && (y > 0 ) ) )
			{	
				return true;
			}
			else
			{
				cout << "Ponto fora do limite!";
				system("Pause");
				return false;
			}
		}

		void menuPrin()
        {
			int op, t, vert;
			do {	
				cout << " Menu: " << endl;
				cout << " 1 - Criar Ponto." << endl;
				cout << " 2 - Criar Reta."  << endl;
				cout << " 3 - Sair"			<< endl;
				cout << " Opcao: "			<< endl;			
				cin.clear();
				cin >> op;
				switch ( op )
				{
					case 1: { if (lerPonto())
							  {	// cria um ponto e insere na lista;
              					LstObjs.inserir( new Ponto(x, y) );			
							  }
                            } break;
					case 2: { if (lerPonto())
							  { cout << "Tamanho:" << endl;
         						cin >> t; 
								if ( t > 0 )
								{
									cout << "Vert(1) ou Hor(0):" << endl;
									cin >> vert;
									if ((0 == vert) || (1 == vert))
									{
										// cria uma reta e insere na lista;
										LstObjs.inserir(new RetaOrtogonal(x, y, t, vert));
									}
								}	
							  }
                            } break;
					case 3: { return; }
					default:{ cout << "Opcao invalida!" << endl; }			
				}
				system("cls");			
				LstObjs.desenha();

				Console::SetCursorPosition ( 0 , 0 );
				system("pause"); 
			} while( op != 3);
		}
};


int _tmain(int argc, _TCHAR* argv[])
{
	Principal p;	
	return 0;
}


/*
Obs:

- Funes inline (definidas no corpo da classe) tornam o programa mais rpido, pois
cada objeto em termos de cdigo executvel ter uma funo-membro para si. 
Entretanto, o executvel ter um tamanho maior.

- Funes no inline (com a assinatura do mtodo separado da implementao) tornam 
o programa mais compreensvel, pois as classe podem ser definidas em arquivos separados.
Ademais, o executvel pode ficar menor, pois os mtodo so compartilhados entre
os objetos de mesmo tipo no cdigo executvel. Entretanto, o executvel poderia
ficar mais lento...

- Desta forma, as funes inline so admissveis quando so simples e pequenas.
*/


